#include "openSE.h"

class CExample1 : public CApplication
{
public:
	openSE*		surface;

	CExample1() : CApplication()
	{
		m_width		= 640;
		m_height	= 480;
		m_name		= string( "Example1" );

		surface		= NULL;
	}
	~CExample1() {}

	virtual void DoFrame( double _timeDelta );
	virtual void SceneInit();
	virtual void SceneEnd();
};

CApplication* CApplication::ApplicationCreate()
{
	return new CExample1;
}

void CApplication::ApplicationDestroy()
{
	delete this;
}

void CExample1::SceneInit()
{
	surface = new openSE;
	assert( surface );

	surface->Open( 100, 100, GetDD() );
}

void CExample1::SceneEnd()
{
	delete surface;
}

void CExample1::DoFrame( double _timeDelta )
{
	static dword_ i = 0x000000;

	surface->Clear( i );
	surface->Blit( GetDD() );

	i += 0x010101;
	if( i > 0x00FFFFFF )
		i = 0x000000;
}
