#include "openSE.h"
#include "Targa.h"

#define SURF_WIDTH		175
#define SURF_HEIGHT		112

class CExample3 : public CApplication
{
public:
	openSE*		surface;
	dword_*		buffer;

	dword_*		picture;

	CExample3() : CApplication()
	{
		m_width		= 640;
		m_height	= 480;
		m_name		= string( "Example3" );

		surface		= NULL;
		buffer		= NULL;
		picture		= NULL;
	}
	~CExample3() {}

	virtual void DoFrame( double _timeDelta );
	virtual void SceneInit();
	virtual void SceneEnd();
};

CApplication* CApplication::ApplicationCreate()
{
	return new CExample3;
}

void CApplication::ApplicationDestroy()
{
	delete this;
}

void CExample3::SceneInit()
{
	surface = new openSE;
	assert( surface );

	buffer = surface->Open( SURF_WIDTH, SURF_HEIGHT, GetDD() );
	assert( buffer );

	int dummy;
	picture = CTarga::LoadTGA( string( "dyhsm.tga" ), dummy, dummy );
	assert( picture );
}

void CExample3::SceneEnd()
{
	delete [] picture;
	delete surface;
}

void CExample3::DoFrame( double _timeDelta )
{
	static dword_ m	= 0xffffff;
	static bool	up = false;

	if( up )
		m += 0x111111;
	else
		m -= 0x111111;

	for( int i=0; i<SURF_WIDTH*SURF_HEIGHT; i++ )
	{
		buffer[i] = ColorSub( picture[i], m );
	}

	surface->Blit( GetDD() );

	if( m == 0x000000 )
		up = true;
	else if( m == 0xffffff )
		up = false;

	Sleep( 50 );
}
