// Application.h: interface for the CApplication class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APPLICATION_H__944878FF_45A2_4BA8_BEC2_596B219018A1__INCLUDED_)
#define AFX_APPLICATION_H__944878FF_45A2_4BA8_BEC2_596B219018A1__INCLUDED_

#include <string>
using std::string;

#include "Draw.h"
#include "Timer.h"

class CApplication  
{
	friend int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow );
	friend LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

private:
	CTimer*						frameTimer;
	CDDraw*						ddraw;

	HWND						m_hWnd;
	HINSTANCE					m_hInstance;
	RECT						m_rcScreen;
	bool						m_bActive;

protected:
	static CApplication*		ApplicationCreate();
	void						ApplicationDestroy();
	

	void						Init( HINSTANCE _hInstance );
	void						UpdateRectangles();
	void						End();
	void						Run();


	int							m_width;
	int							m_height;
	string						m_name;

public:
	CApplication();
	~CApplication();

	inline CDDraw*				GetDD() { return ddraw; }
	inline HWND					GetHWND() { return m_hWnd; }
	inline HINSTANCE			GetInstance() { return m_hInstance; }

	// User functions
	virtual void				SceneInit();
	virtual void				SceneEnd();
	virtual void				DoFrame( double _timeDelta );
};

#endif // !defined(AFX_APPLICATION_H__944878FF_45A2_4BA8_BEC2_596B219018A1__INCLUDED_)
