// Color.h: interface for the CColor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLOR_H__2405DF0D_64A8_4329_8BBA_95209CDFD97B__INCLUDED_)
#define AFX_COLOR_H__2405DF0D_64A8_4329_8BBA_95209CDFD97B__INCLUDED_

#include "Types.h"

extern "C"
{
inline dword_	ColorAdd( dword_* result, dword_* a, dword_* b, const dword_ num_dwords );
inline dword_	ColorSub( dword_* result, dword_* a, dword_* b, const dword_ num_dwords );
inline dword_	ColorBlend( dword_* result, dword_* a, dword_* b, const dword_ alpha, const dword_ num_dwords );
}

inline dword_ ColorAdd( const dword_ a, const dword_ b )
{
	_asm
	{
		movd mm0, a
		movd mm1, b
		paddusb mm0,mm1
		movd a, mm0

		emms
	}

	return a;
}

inline dword_ ColorSub( const dword_ a, const dword_ b )
{
	_asm
	{
		movd mm0, a
		movd mm1, b
		psubusb mm0,mm1
		movd a, mm0

		emms
	}

	return a;
}

inline dword_ ColorBlend( const dword_ a, const dword_ b, const dword_ alpha )
{

	// old version (maybe slower?!?!)
/*	dword_ r	= ( ( (a&0xff00ff) * (255-alpha) ) + ( (b&0xff00ff) * alpha ) ) >> 8;
	dword_ g	= ( ( (a&0x00ff00) * (255-alpha) ) + ( (b&0x00ff00) * alpha ) ) >> 8;
	dword_ bl	= ( ( (a&0x0000ff) * (255-alpha) ) + ( (b&0x0000ff) * alpha ) ) >> 8;

	r	&= 0xff0000;
	g	&= 0x00ff00;
	bl	&= 0x0000ff;

	return r | g | bl; */

	// fast mmx version
	_asm
	{
		movd mm0, a
		movd mm1, b
		pxor mm6, mm6	// makes mm6 == 0

		// fixes alpha to word aligment
		movd mm7, alpha
		pslld mm7, 8
		paddusb mm7, alpha
		pslld mm7, 8
		paddusb mm7, alpha
		punpcklbw mm7, mm6

		// inner loop
		punpcklbw mm0, mm6		// byte-->word(pixel 1)
		punpcklbw mm1, mm6		// byte-->word(pixel 1)
		psubw mm0, mm1			// a-b
		pmullw mm0, mm7			// pixel 1 * alpha
		psrlw mm0, 8			// shifts word elements 8 to the right.
		paddb mm0, mm1			// add (b) to result
		packuswb mm0,mm6		// convert back into byte form

		movd a, mm0

		emms
	}

	return a;
}

inline void ColorClear( void *d, unsigned __int32 value, int num_dwords )
{
	_asm
	{
		mov	eax, value
		mov ecx, num_dwords
		mov edi, d
		rep stosd
	}
}

#endif // !defined(AFX_COLOR_H__2405DF0D_64A8_4329_8BBA_95209CDFD97B__INCLUDED_)
