// Timer.h: interface for the CTimer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TIMER_H__E9BBF61A_0C02_476A_BD6E_DBBAE537AFEB__INCLUDED_)
#define AFX_TIMER_H__E9BBF61A_0C02_476A_BD6E_DBBAE537AFEB__INCLUDED_

#include <cassert>

class CTimer  
{
private:
	double			m_startTime;
	LARGE_INTEGER	m_qpcFreq;
	LARGE_INTEGER	m_qpcCount;

public:
	CTimer()
	{
		QueryPerformanceFrequency( &m_qpcFreq );
		assert( &m_qpcFreq );
		this->Reset();
	}

	void			Reset();
	double			Time();
};

inline void CTimer::Reset()
{
	QueryPerformanceCounter( &m_qpcCount );
	m_startTime = (double)m_qpcCount.QuadPart / m_qpcFreq.QuadPart;
}

inline double CTimer::Time()
{
	QueryPerformanceCounter( &m_qpcCount );
	return (double)m_qpcCount.QuadPart / m_qpcFreq.QuadPart - m_startTime;
}

#endif // !defined(AFX_TIMER_H__E9BBF61A_0C02_476A_BD6E_DBBAE537AFEB__INCLUDED_)
